/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/calendar/gregorian/gregorian_output.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef gregorian_output
#define gregorian_output
#include "ucs/value_array.h"
/*
*  output.h
*
*  This module contains all function headers for 
*  time-stamp to string translation. 
*
*/

/*
*  Routine:  cal_standard_gregorian_v1_gen_s_array
*
*  Description:  Create a parsed version of the time-stamp
*
*  Arguments: span      --  (IN) : time-stamp
*             val_array --  (OUT): parsed version of time-stamp
*
*  Return Value: Error code
*
*  Errors: conversion_error
*
*  Side Effects: Overwrites val_array
*/

error_type cal_standard_gregorian_v1_gen_s_array(span_type span,value_array_type *val_array);

/*
*  Routine:  cal_standard_gregorian_v1_gen_e_array
*
*  Description:  Create a parsed version of the time-stamp
*
*  Arguments: event            --  (IN) : time-stamp
*             val_array        --  (OUT): parsed version of time-stamp
*
*  Return Value: Error code
*
*  Errors: conversion_error
*
*  Side Effects: Overwrites val_array
*/

error_type cal_standard_gregorian_v1_gen_e_array(event_type event, value_array_type *val_array);


/*
*  Routine:  cal_standard_gregorian_v1_gen_i_array
*
*  Description:  Create a parsed version of the time-stamp
*
*  Arguments: interval         --  (IN) : time-stamp
*             val_array        --  (OUT): first half of parsed version of time-stamp
*
*  Return Value: Error code
*
*  Errors: conversion_error
*
*  Side Effects: Overwrites val_array_1 and val_array_2
*/

error_type cal_standard_gregorian_v1_gen_i_array(interval_type interval, value_array_type *val_array);
#endif
