#define MULT_TABLE_MAX 16  /*if > 16, must change table*/
#define COARSENESS 0x8000
#define COARSENESS_SHIFTED 0x80000000
unsigned char mult_table[MULT_TABLE_MAX][MULT_TABLE_MAX];
unsigned int uniform_tree_height = 0;
int pregammas[101];
int maxqueue = 0;
tree_node_type spare_nodes[10000];
int allocated = 0;
tree_node_type *uniform_tree;
queue_node_type queue[PRECISION*8 + 2];

tree_node_type *build_spike_tree(unsigned int height) {
  tree_node_type *node, *finger, *build_uniform_tree();

  node = &spare_nodes[allocated++];
  
  if (height < 8)  {
    node->value = 0;
    node->left = NULL;
    node->leftrods = 0;
    node->rightrods = PRECISION;
    node->right = build_spike_tree(height + 1);
    }
  else {
    node->value = 0;
    node->left = NULL;
    node->right = build_uniform_tree(PRECISION,0,0,PRECISION);
    }
  return node;
}

tree_node_type *build_uniform_tree(unsigned int current, unsigned int height,
				   unsigned int lower, unsigned int upper) {
  tree_node_type *node, *finger;

  node = &spare_nodes[allocated++];
  node->value = lower + ((upper - lower) >> 1);
  if (current == 1) {
    node->leftrods = node->value;
    node->rightrods = PRECISION - node->value - 1;
    /*
    if (upper == PRECISION) node->value = PRECISION;
    if (upper == PRECISION) node->leftrods = PRECISION;
    if (upper == PRECISION) node->rightrods = 0;
    */
#ifdef TESTING
  printf("node %d leftrods %d rightrods %d\n", node->value, node->leftrods, node->rightrods);
#endif
    node->left = NULL;
    node->right = NULL;
    }
  else {
    node->leftrods = node->value;
    node->rightrods = PRECISION - node->value;
#ifdef TESTING
  printf("node %d leftrods %d rightrods %d\n", node->value, node->leftrods, node->rightrods);
#endif
    node->left = (void *)build_uniform_tree(current >> 1,height+1,lower,node->value);
    node->right = (void *)build_uniform_tree(current >> 1,height+1,node->value,upper);
    }
  if (height > uniform_tree_height) uniform_tree_height = height;
  /*
  node->height = height;
  */
  return node;
}

  double f;

  for (i=0;i<MULT_TABLE_MAX;i++) for (j=0;j<MULT_TABLE_MAX;j++) mult_table[i][j] = i*j;

#define GAMMA_MULT PRECISION * PRECISION / 100.0
  for (i=0;i<101;i++) {
    f = i;
    pregammas[i] = (int) ceil(f * GAMMA_MULT);
    /* printf("%d %d %f \n", i, pregammas[i], (i * (GAMMA_MULT)));*/
    }

  uniform_tree = build_uniform_tree(PRECISION,0,0,PRECISION);
  /*
  uniform_tree = build_spike_tree(1);
  */
