/* Test code for the determinate sequence */
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt.h"
#define EVENTS_IN_R 4
#define INTERVALS_IN_P 4
#define SEED 0x2F678324
/*
#define PERIOD_OF_INDETERMINACY 2000000
*/
#define PERIOD_OF_INDETERMINACY 24
#define NUM_OF_TRIALS 1
#define NUM_OF_GAMMAS 100
/*
#define NUM_OF_WIDTHS 108
#define MAX_WIDTH 108
*/
#define NUM_OF_WIDTHS 108
/*
#define NUM_OF_RUNS 100
*/
#define NUM_OF_RUNS 10
static int widths[NUM_OF_WIDTHS];
static timings[NUM_OF_WIDTHS];

/*
static int gammas[NUM_OF_GAMMAS] = {
1, 2, 3, 4, 5, 6, 7, 8, 9,
10,11,12,13,14,15,16,17,18,19,
20,21,22,23,24,25,26,27,28,29,
30,31,32,33,34,35,36,37,38,39,
40,41,42,43,44,45,46,47,48,49,
50,51,52,53,54,55,56,57,58,59,
60,61,62,63,64,65,66,67,68,69,
70,71,72,73,74,75,76,77,78,79,
80,81,82,83,84,85,86,87,88,89,
90,91,92,93,94,95,96,97,98,99,
100};
*/

extern dist_type distributions[MAX_DISTRIBUTION];
context_space_type context_space;
context_type context = &context_space;

int main()
{
  packed_event_space_type received[EVENTS_IN_R];
  event_space_type dummy;
  event_space_type received_upack[EVENTS_IN_R];
  packed_event_space_type starting_in_production[INTERVALS_IN_P];
  packed_event_space_type terminating_in_production[INTERVALS_IN_P];
  event_space_type starting_in_production_upack[INTERVALS_IN_P];
  event_space_type terminating_in_production_upack[INTERVALS_IN_P];
  interval_space_type in_production[INTERVALS_IN_P];
  interval_space_type in_production_upack[INTERVALS_IN_P];
  int k, x, j, i, r, p, temp;
  void gettimeofday();
  struct timeval tp1, tp2;
  int temp1, temp2, plausibility;

  context->precision.precision = 5;
  context->resolution = packed_chunked;
   
  error_handler();
  tadt_init();

  /* Initialize Recieved */
  received[0].word[1] = (31+28+31+30+10)*86400;
  received[1].word[1] = (31+28+31+30+30)*86400;
  received[2].word[1] = (31+28+31+30+31+8)*86400;
  received[3].word[1] = (31+28+31+30+31+13)*86400;
  received[0].chunked.chunks = 20;
  received[1].chunked.chunks = 20;
  received[2].chunked.chunks = 20;
  received[3].chunked.chunks = 20;
  for (i=0;i<EVENTS_IN_R;i++) {
    received[i].chunked.ts_type = packed_indeterminate;
    received[i].chunked.missing = FALSE;
    received[i].chunked.chunksize = 1;
    received[i].chunked.sign = 0;
    }

#define SECS_IN_DAY 86400

  /* Initialize In_Production */
  starting_in_production[0].word[1] = (31+28+1)*SECS_IN_DAY;
  starting_in_production[1].word[1] = (31+28+31+30+31+1)*SECS_IN_DAY;
  starting_in_production[2].word[1] = (31+28+31+30+31+1)*SECS_IN_DAY;
  starting_in_production[3].word[1] = (31+28+31+1)*SECS_IN_DAY;
  terminating_in_production[0].word[1] = (31+28+31+30+31+1)*SECS_IN_DAY;
  terminating_in_production[1].word[1] = (31+28+31+30+31+30+1)*SECS_IN_DAY;
  terminating_in_production[2].word[1] = (31+28+31+30+31+30+31+1)*SECS_IN_DAY;
  terminating_in_production[3].word[1] = (31+28+31+30+1)*SECS_IN_DAY;
  starting_in_production[0].chunked.chunks = 20;
  terminating_in_production[0].chunked.chunks = 20;
  starting_in_production[1].chunked.chunks = 20;
  terminating_in_production[1].chunked.chunks = 20;
  starting_in_production[2].chunked.chunks = 20;
  terminating_in_production[2].chunked.chunks = 20;
  starting_in_production[3].chunked.chunks = 20;
  terminating_in_production[3].chunked.chunks = 20;
  for (i=0;i<INTERVALS_IN_P;i++) {
    starting_in_production[i].chunked.ts_type = packed_indeterminate;
    starting_in_production[i].chunked.sign = 0;
    starting_in_production[i].chunked.missing = FALSE;
    starting_in_production[i].chunked.chunksize = 1;
    terminating_in_production[i].chunked.ts_type = packed_indeterminate;
    terminating_in_production[i].chunked.sign = 0;
    terminating_in_production[i].chunked.missing = FALSE;
    terminating_in_production[i].chunked.chunksize = 1;
    }

  for (i=0;i<INTERVALS_IN_P;i++) {
    in_production[i].start = (event_type)&starting_in_production[i];
    in_production[i].terminate = (event_type)&terminating_in_production[i];
    in_production_upack[i].start = &starting_in_production_upack[i];
    in_production_upack[i].terminate = &terminating_in_production_upack[i];
    }

/*
  for (r=0;r<EVENTS_IN_R;r++) dump_packed_event(&received[r]," event ");
  for (r=0;r<INTERVALS_IN_P;r++) dump_packed_event(&starting_in_production[r]," start ");
  for (r=0;r<INTERVALS_IN_P;r++) dump_packed_event(&starting_in_production[r]," terminate ");
*/

  temp = 0;

  for (p=0;p<INTERVALS_IN_P;p++) 
    tadt_swizzle_i(&in_production[p],&in_production_upack[p]);
  for (r=0;r<EVENTS_IN_R;r++) 
    tadt_swizzle_e(&received[r],&received_upack[r]);
/*
  for (r=0;r<EVENTS_IN_R;r++) 
    dump_event(&received_upack[r], "event ");
  for (r=0;r<INTERVALS_IN_P;r++) {
    dump_event(in_production_upack[r].start, "interval start");
    dump_event(in_production_upack[r].terminate, "interval end");
    }
*/

  r = 0;
  p = 0;
  srand(SEED);

#define PLAUSIBILITY 1
/* From AVERAGE */
  for (i=0;i<NUM_OF_WIDTHS;i++) {
    widths[i] = i*25 * PERIOD_OF_INDETERMINACY + 1;
    /*
    widths[i] = i * PERIOD_OF_INDETERMINACY + 1;
    */
    timings[i] = 0;
    }

  for (k=0;k<NUM_OF_WIDTHS;k++) {

    for (x=0;x<NUM_OF_RUNS;x++) {
      for (i=1;i<=NUM_OF_GAMMAS;i++) {
       
        plausibility = i;

        for (j=0;j<EVENTS_IN_R;j++) {
          temp1 = rand() % widths[k];
	  /*
          received[j].word[1] = temp1 + 0x8001;
	  */
          received[j].word[1] = temp1 + 1;
          }

        for (j=0;j<INTERVALS_IN_P;j++) {
          temp1 = rand() % widths[k];
	  /*
          starting_in_production[j].word[1] = temp1 + 0x8001;
	  */
          starting_in_production[j].word[1] = temp1 + 1;
          temp1 = rand() % widths[k];
	  /*
          terminating_in_production[j].word[1] = temp1 + 0x8001;
	  */
          terminating_in_production[j].word[1] = temp1 + 1;
          }

        gettimeofday(&tp1,NULL);

            for (j=0; j<NUM_OF_TRIALS; j++) {
              for (p=0;p<INTERVALS_IN_P;p++) {
                tadt_swizzle_i(&in_production[p],&in_production_upack[p]);
                tadti_shrink_t(0,in_production_upack[p].terminate,
 	             in_production_upack[p].terminate);
                tadti_shrink_s(0,in_production_upack[p].start,
                     in_production_upack[p].start);
                }
              for (r=0;r<EVENTS_IN_R;r++) 
                tadt_swizzle_e(&received[r],&received_upack[r]);

              reset_quick_space_allocation();
              for (p=0;p<INTERVALS_IN_P;p++) {
                for (r=0;r<EVENTS_IN_R;r++) {
                  if (tadti_e_precedes_e(plausibility,&received_upack[r],
			                in_production_upack[p].terminate)) {
		      /* / * */
                    if (tadti_e_precedes_e(plausibility,in_production_upack[p].start, 
			                  &received_upack[r])) {
                      tadti_first(plausibility,&received_upack[r],
                                 in_production_upack[p].terminate,
                                 &dummy);
                      tadti_last(plausibility,in_production_upack[p].start,
                                &received_upack[r],
                                &dummy);
                          temp += 1;
                      }
                    }
				/* * /
				temp +=1;} */
                  }
                }
              }

        gettimeofday(&tp2,NULL);
  
        temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
        temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
        temp1 = temp2 - temp1;

        /*
        timings[k] += temp1/(NUM_OF_TRIALS*NUM_OF_EVENTS*NUM_OF_EVENTS);
        */
        timings[k] += temp1;

        }
      }
      fprintf(stderr,"%d\n", k);
    }

  for (k=0;k<NUM_OF_WIDTHS;k++) {
    printf("%d\n", timings[k]/(12*100*NUM_OF_RUNS));
    /*
    printf("%d\n", timings[k]);
    */
    }
  return FALSE;
/* END  From AVERAGE */


}
